Package org.zkoss.bind

## Interface Converter<U,​B,​C extends Component>

- All Known Implementing Classes:
    `AbstractListModelConverter`, `AbstractSelectedIndexConverter`, `BiglistboxSelectedIndexConverter`, `BiglistboxSelectedObjectConverter`, `ChildrenBindingConverter`, `ChosenboxModelConverter`, `ComboboxModelConverter`, `ComboboxSelectedIndexConverter`, `ComboboxSelectedItemConverter`, `DefaultJSONBindingParamConverter`, `DropuploadNativeConverter`, `EncodedURLConverter`, `ErrorMessageConverter`, `FormatedDateConverter`, `FormatedNumberConverter`, `FormattedTemporalConverter`, `FormattedTimeConverter`, `GridModelConverter`, `GsonConverter`, `GsonConverter`, `ImageContentConverter`, `JacksonConverter`, `ListboxModelConverter`, `ListboxSelectedIndexConverter`, `ListboxSelectedItemConverter`, `ListboxSelectedItemsConverter`, `ObjectBooleanConverter`, `RadiogroupModelConverter`, `RadiogroupSelectedIndexConverter`, `RadiogroupSelectedItemConverter`, `SearchboxModelConverter`, `SelectboxModelConverter`, `SelectboxSelectedIndexConverter`, `SelectboxSelectedItemConverter`, `TabboxModelConverter`, `TabboxSelectedIndexConverter`, `TabboxSelectedTabConverter`, `TreeModelConverter`, `TreeSelectedItemConverter`, `TreeSelectedItemsConverter`, `UriConverter`

      public interface Converter<U,​B,​C extends Component>

  Generic binding conversion interface. U is the value type of the Component attribute, B is the property type of the Bean and C is the component type of the converter.

  Since:
    6.0.0
  Author:
    henrichen, dennis

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.Object` | `IGNORED_VALUE` | Indicates the returned value should be ignored to load to a component or save to a bean, It is useful for writing a converter to manipulate component directly when loading or saving Note : If you want to return `IGNORED_VALUE` in the converter method, then you need to set U or B to Object.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `B` | `coerceToBean​(U compAttr, C component, BindContext ctx)` | Coerces a value to bean value to save to a bean
    `U` | `coerceToUi​(B beanProp, C component, BindContext ctx)` | Coerces a value to another value to load to a component

- - ### Field Detail

    - #### IGNORED_VALUE

          static final java.lang.Object IGNORED_VALUE

      Indicates the returned value should be ignored to load to a component or save to a bean, It is useful for writing a converter to manipulate component directly when loading or saving Note :
      If you want to return `IGNORED_VALUE` in the converter method, then you need to set U or B to Object.
      Since:
        6.0.1

  - ### Method Detail

    - #### coerceToUi

          U coerceToUi​(B beanProp,
                       C component,
                       BindContext ctx)

      Coerces a value to another value to load to a component
      Parameters:
        `beanProp` - the bean value
        `component` - the component to be loaded the value
        `ctx` - the bind context
      Returns:
        the value to load to a component

    - #### coerceToBean

          B coerceToBean​(U compAttr,
                         C component,
                         BindContext ctx)

      Coerces a value to bean value to save to a bean
      Parameters:
        `compAttr` - the value of component attribute.
        `component` - the component provides the value
        `ctx` - the bind context
      Returns:
        the value to save to a bean